#version 330

layout (std140) uniform Matrices
{
	mat4 m_pvm;
	mat4 m_viewModel;
	mat3 m_normal;
};

layout (std140) uniform Lights
{
	vec4 l_pos, l_spotDir;		// camera space
	float l_spotCutOff;			// cosinus of angle
};

in vec4 position;	// local space
in vec3 normal;		// local space

out Data
{
	vec3 normal;
	vec3 eye;
	vec3 lightDir;
} DataOut;

//----------------------------------------------------------------
// TODO:
// 1) Pass the transformed normal, light and eye vectors to the fragment shader.
//----------------------------------------------------------------

void main()
{
	vec4 pos = m_viewModel * position;

	DataOut.normal = normalize(m_normal * normal);
	DataOut.eye = vec3(-pos);
	DataOut.lightDir = vec3(l_pos - pos);

	gl_Position = m_pvm * position;	
}